package torneio;

import java.util.Random;


public class Baralho {
	
	private Carta[] cartas = new Carta[40];
	private String[] valorNome;
	private String[] naipe;
	
	public Baralho(){
		valorNome = new String[10];
		valorNome[0] = "quatro";
		valorNome[1] = "cinco";
		valorNome[2] = "seis";
		valorNome[3] = "sete";
		valorNome[4] = "dama";
		valorNome[5] = "valete";
		valorNome[6] = "rei";
		valorNome[7] = "as";
		valorNome[8] = "dois";
		valorNome[9] = "tres";
		
		naipe = new String[4];
		naipe[0] = "ouros";
		naipe[1] = "espadas";
		naipe[2] = "copas";
		naipe[3] = "paus";
	}
	
	private void reiniciarBaralho(){
		for (int i=0;i<40;i++){
			int valor = i/4;
			int resto = i%4;
			
			int valorUsado = valor+1;
			String descricao = valorNome[valor]+ " de " + naipe[resto];
			
			if (i==3) {
				valorUsado = 14;
				descricao += " (zap)";
			}else if (i==14){
				valorUsado = 13;
				descricao += " (sete copas)";
			}else if (i==29){
				valorUsado = 12;
				descricao += " (espadilha)";
			}else if (i==12){
				valorUsado = 11;
				descricao += " (sete ouros)";
			}
			cartas[i] = new Carta(valorUsado, descricao);
		}
	}
	
	protected Carta[] darAsCartas(int numeroDeCartas){
		reiniciarBaralho();
		 Random rand = new Random();
		 Carta[] resultado = new Carta[numeroDeCartas];
		 int total = 40;
		 for (int i=0;i<numeroDeCartas;i++){
			 int indice = rand.nextInt(total);
			 resultado[i] = cartas[indice];
			 total--;
			 cartas[indice]  = cartas[total];
		 }
		 return resultado;
	}
	
}
