package torneio;


public class LogInterno {
	public int[] placar = new int[2];
	public int numeroDaRodadaAtual = 1;
	public Carta[][] cartasNasMaos = new Carta[2][3];
	public Carta[][] cartasJogadas = new Carta[2][3];
	public Time primeiroAJogar = Time.Nenhum;
	public Time ultimoAAumentar = Time.Nenhum;
	public int valorAtualDaRodada = 1;
	public int numeroDaMaoAtual = 1;
	public int[] quantidadeDeVezesAumentou;
	public int[] quantidadeDeVezesQueAceitou;
	

	public LogInterno(int pontos1, int pontos2, Carta[] todasCartasDasMaos, boolean adversarioJogou, Time quemComeca, int valorAtual, int maoAtual, int[] vezesAumentou, int[] vezesAceitou){
		placar[0] = pontos1;
		placar[1] = pontos2;

		for (int x=0;x<6;x++){
			int jog = x/3;
			int carta = x%3;
			cartasNasMaos[jog][carta] = todasCartasDasMaos[x];
		}
		
		// ORDENANDO CARTAS
		Carta temp;
		for (int j=0;j<2;j++){
			for (int x=0;x<3;x++){
				for (int y=1;y<3;y++){
					if (cartasNasMaos[j][y].getValor()<cartasNasMaos[j][y-1].getValor()){
						temp = cartasNasMaos[j][y];
						cartasNasMaos[j][y] = cartasNasMaos[j][y-1];
						cartasNasMaos[j][y-1] = temp;
					}
				}
			}
		}
		
		
		primeiroAJogar = quemComeca;
		valorAtualDaRodada = valorAtual;
		numeroDaMaoAtual = maoAtual;
		quantidadeDeVezesAumentou = vezesAumentou;
		quantidadeDeVezesQueAceitou = vezesAceitou;
	}
	
	public LogAtualDoJogo gerarLogEspecifico(Time timeX){
		int atual = 0;
		int outro = 1;
		if (timeX == Time.Time2){
			atual = 1;
			outro = 0;
		}
		int contCartas = 0;
		for (int x=0;x<3;x++){
			if (cartasNasMaos[atual][x] != null) contCartas++;
		}
		Carta[] suasCartas = new Carta[contCartas];
		for (int x=0;x<contCartas;x++){
			suasCartas[x] = cartasNasMaos[atual][x].Clone();
		}
		
		contCartas = 0;
		for (int x=0;x<3;x++){
			if (cartasJogadas[atual][x] != null) contCartas++;
		}
		Carta[] cartasVoceJogou = new Carta[contCartas];
		for (int x=0;x<contCartas;x++){
			cartasVoceJogou[x] = cartasJogadas[atual][x].Clone();
		}
		
		contCartas = 0;
		for (int x=0;x<3;x++){
			if (cartasJogadas[outro][x] != null) contCartas++;
		}
		Carta[] cartasQueOAdversarioJogou = new Carta[contCartas];
		for (int x=0;x<contCartas;x++){
			cartasQueOAdversarioJogou[x] = cartasJogadas[outro][x].Clone();
		}
		
		boolean adversarioJogou = false;
		if (cartasQueOAdversarioJogou.length == numeroDaRodadaAtual) adversarioJogou = true;
		
		boolean euAumentei  = false;
		if (ultimoAAumentar == timeX) euAumentei = true;
		
		boolean euComeco = false;
		if (primeiroAJogar == timeX) euComeco = true;
		
    	return new LogAtualDoJogo(placar[atual],placar[outro], numeroDaRodadaAtual, suasCartas, cartasVoceJogou, cartasQueOAdversarioJogou, 
    			adversarioJogou, euAumentei, valorAtualDaRodada, numeroDaMaoAtual, quantidadeDeVezesAumentou[outro], quantidadeDeVezesAumentou[atual], quantidadeDeVezesQueAceitou[outro], euComeco);		
	}
	
	public void imprimir(){
		String tag = "";
		String tag2 = "";
		String tag3 = "";
		String tag4 = "";
		
	    for (int x=0;x<3;x++){
	    	if (cartasNasMaos[0][x] == null) tag += "[ ]";
	    	else tag += "["+ cartasNasMaos[0][x].getValor() +"]";
	    	if (cartasNasMaos[1][x] == null) tag2 += "[ ]";
	    	else tag2 += "["+ cartasNasMaos[1][x].getValor() +"]";
	    	if (cartasJogadas[0][x] == null) tag3 += "[ ]";
	    	else tag3 += "["+ cartasJogadas[0][x].getValor() +"]";	    	
	    	if (cartasJogadas[1][x] == null) tag4 += "[ ]";
	    	else tag4 += "["+ cartasJogadas[1][x].getValor() +"]";

	    	
	    } 	
		System.out.println(placar[0] +"x"+placar[1] + " M" + numeroDaMaoAtual + ":R"+numeroDaRodadaAtual+":V"+valorAtualDaRodada + "  T1:" + tag + " | T2:"+ tag2 + "  Jogadas: T1:" + tag3 + " | T2:"+ tag4 + "   (" + quantidadeDeVezesAumentou[0]+","+quantidadeDeVezesAumentou[1]+ ","+quantidadeDeVezesQueAceitou[0]+","+quantidadeDeVezesQueAceitou[1]+")");
		
		/*
		public int[] placar = new int[2];
		public int numeroDaRodadaAtual;
		public Carta[][] cartasNasMaos = new Carta[2][3];
		public Carta[][] cartasJogadas = new Carta[2][3];
		public Time primeiroAJogar = Time.Nenhum;
		public Time ultimoAAumentar = Time.Nenhum;
		public int valorAtualDaRodada;
		public int numeroDaMaoAtual;
		public int[] quantidadeDeVezesAumentou;
		public int[] quantidadeDeVezesQueAceitou;*/
	}
	
	public void jogarCarta(Time timeX, int idCarta){
		int rodada = numeroDaRodadaAtual;
		
		int atual = 0;
		if (timeX == Time.Time2){
			atual = 1;
		}
		//System.out.println("    Jogando ("+timeX.toString()+", rodada:"+rodada+"): " +  cartasNasMaos[atual][idCarta].getDescricao());
		cartasJogadas[atual][rodada-1] = cartasNasMaos[atual][idCarta];
		cartasNasMaos[atual][idCarta] = cartasNasMaos[atual][3-rodada];
		cartasNasMaos[atual][3-rodada] = null;
		 
		if (idCarta == 0 && rodada==1){
			Carta temp = cartasNasMaos[atual][0];
			cartasNasMaos[atual][0] = cartasNasMaos[atual][1];
			cartasNasMaos[atual][1] = temp;
		}
		
	}	
}