package torneio;


public class Rodadas {
	
	public static boolean LOG = false;
	
	public enum Status {RodadaNaoEncerrada,Time1Ganhou, Time2Ganhou,Empatou};
	public static int[] executarRodadas(Jogador[] jogadores, LogInterno estadoAtual){
		int[] resultado = new int[2];
		Time proximoAJogar = estadoAtual.primeiroAJogar;
		boolean fimDaMao = false;
		Jogada ultimaJogada = null;
		Jogada penultimaJogada = null;
		int cartasJogadas = 0;
		Status[] rodadas = new Status[3];
		rodadas[0] = Status.RodadaNaoEncerrada;
		rodadas[1] = Status.RodadaNaoEncerrada;
		rodadas[2] = Status.RodadaNaoEncerrada;
		estadoAtual.numeroDaRodadaAtual = 1;
		
		while (!fimDaMao){
			if (LOG) estadoAtual.imprimir();
			penultimaJogada = ultimaJogada;
			try{
			ultimaJogada = jogadores[idDoTime(proximoAJogar)].jogar(estadoAtual.gerarLogEspecifico(proximoAJogar));
			}catch(Exception e){
				ultimaJogada = Jogada.AbandonarRodada;
				if (LOG) System.err.println("Problemas na jogada atual: " + jogadores[idDoTime(proximoAJogar)].nomeDoJogador());
			}
			if (LOG) System.out.println("  =" + ultimaJogada.toString() + "  " + proximoAJogar.toString());
			
			if (ultimaJogada == Jogada.AbandonarRodada){
				resultado[idDoTime(proximoAJogar)] = 0;
				resultado[idDoTime(outroTime(proximoAJogar))] = estadoAtual.valorAtualDaRodada;
				return resultado;

			}else if (ultimaJogada == Jogada.AceitarAumento){
				System.err.println("O time " + proximoAJogar.toString() + " AceitouAumento sem haver aumento: " + jogadores[idDoTime(proximoAJogar)].nomeDoJogador());
				resultado[idDoTime(proximoAJogar)] = 0;
				resultado[idDoTime(outroTime(proximoAJogar))] = estadoAtual.valorAtualDaRodada;
				return resultado;

			
//			}else if (ultimaJogada == Jogada.AceitarAumento){
//				estadoAtual.valorAtualDaRodada += 3;
//				if (estadoAtual.valorAtualDaRodada == 4) estadoAtual.valorAtualDaRodada = 3;
//				estadoAtual.quantidadeDeVezesQueAceitou[idDoTime(proximoAJogar)]++;
//				proximoAJogar = outroTime(proximoAJogar);

			
			}else if (ultimaJogada == Jogada.JogarCarta1 || ultimaJogada == Jogada.JogarCarta2 || ultimaJogada == Jogada.JogarCarta3){
				cartasJogadas++;
				if (cartasJogadas == 6) fimDaMao=true;
				int id=0;
				if (ultimaJogada == Jogada.JogarCarta2) id = 1;
				else if (ultimaJogada == Jogada.JogarCarta3) id = 2;
				if (id > 0){
					if (cartasJogadas>4) {
						System.err.println("Tentou jogar carta que nao tem: " + jogadores[idDoTime(proximoAJogar)].nomeDoJogador());
						id=0;
					}else if (cartasJogadas>2 && id>1) {
							System.err.println("Tentou jogar carta que nao tem: " + jogadores[idDoTime(proximoAJogar)].nomeDoJogador());
							id=0;
					}
				}
				
				estadoAtual.jogarCarta(proximoAJogar, id);
				if (cartasJogadas % 2 == 0){
					estadoAtual.numeroDaRodadaAtual++;
					int rodadaConcluida = cartasJogadas/2-1;
					//estadoAtual.imprimir();
					int v1 = estadoAtual.cartasJogadas[0][rodadaConcluida].getValor();
					int v2 = estadoAtual.cartasJogadas[1][rodadaConcluida].getValor();
					if (v1 == v2) {
						rodadas[rodadaConcluida] = Status.Empatou;
						proximoAJogar = outroTime(proximoAJogar);
					}
					else if (v1 > v2) {
						rodadas[rodadaConcluida] = Status.Time1Ganhou;
						proximoAJogar = Time.Time1;
					}
					else if (v1 < v2) {
						rodadas[rodadaConcluida] = Status.Time2Ganhou;
						proximoAJogar = Time.Time2;
					}
					if (rodadaConcluida == 1){
						if (rodadas[0] == Status.Empatou && rodadas[1] != Status.Empatou){
							if (rodadas[1] == Status.Time1Ganhou){
								resultado[0] = estadoAtual.valorAtualDaRodada;
							}else{
								resultado[1] = estadoAtual.valorAtualDaRodada;
							}
							fimDaMao = true;
							break;
						}else if (rodadas[1] == Status.Empatou && rodadas[0] != Status.Empatou){
							if (rodadas[0] == Status.Time1Ganhou){
								resultado[0] = estadoAtual.valorAtualDaRodada;
							}else{
								resultado[1] = estadoAtual.valorAtualDaRodada;
							}
							fimDaMao = true;
							break;
						}else if (rodadas[0] != Status.Empatou && rodadas[0] == rodadas[1]){
							if (rodadas[1] == Status.Time1Ganhou){
								resultado[0] = estadoAtual.valorAtualDaRodada;
							}else{
								resultado[1] = estadoAtual.valorAtualDaRodada;
							}
							fimDaMao = true;
							break;
						}
					}
					if (rodadaConcluida == 2){
						if (rodadas[2] == Status.Time1Ganhou){
							resultado[0] = estadoAtual.valorAtualDaRodada;
						}else if (rodadas[2] == Status.Time2Ganhou){
							resultado[1] = estadoAtual.valorAtualDaRodada;
						}else if (rodadas[0] == Status.Time1Ganhou){
							resultado[0] = estadoAtual.valorAtualDaRodada;
						}else if (rodadas[0] == Status.Time2Ganhou){
							resultado[1] = estadoAtual.valorAtualDaRodada;
						}else{
						}						
						fimDaMao = true;
						break;
						
					}
				}else{
					proximoAJogar = outroTime(proximoAJogar);
				}
			
			}else if (ultimaJogada == Jogada.SolicitarAumento){
				if (estadoAtual.valorAtualDaRodada == 12){
					System.err.println("O time " + proximoAJogar.toString() + " tentou aumentar aps os 12 pontos: "  + jogadores[idDoTime(proximoAJogar)].nomeDoJogador());
					if (proximoAJogar == Time.Time1){
						resultado[1] = estadoAtual.valorAtualDaRodada;
					}else{
						resultado[0] = estadoAtual.valorAtualDaRodada;	
					}
					return resultado;
				}
				if (estadoAtual.ultimoAAumentar == proximoAJogar){
					System.err.println("O time " + proximoAJogar.toString() + " tentou aumentar duas vezes: "  + jogadores[idDoTime(proximoAJogar)].nomeDoJogador());
					if (proximoAJogar == Time.Time1){
						resultado[1] = estadoAtual.valorAtualDaRodada;
					}else{
						resultado[0] = estadoAtual.valorAtualDaRodada;	
					}
					return resultado;
				}
				estadoAtual.ultimoAAumentar = proximoAJogar;
				estadoAtual.quantidadeDeVezesAumentou[idDoTime(proximoAJogar)]++;
				if (penultimaJogada != null && penultimaJogada == Jogada.SolicitarAumento){
					estadoAtual.valorAtualDaRodada += 3;
					if (estadoAtual.valorAtualDaRodada == 4) estadoAtual.valorAtualDaRodada = 3;
				}
				Time temp = outroTime(proximoAJogar);
				while (ultimaJogada == Jogada.SolicitarAumento && estadoAtual.valorAtualDaRodada < 12){

					
					
					penultimaJogada = ultimaJogada;
					try{
						ultimaJogada = jogadores[idDoTime(temp)].aceitaAumento(estadoAtual.gerarLogEspecifico(temp));
					}catch(Exception e){
						ultimaJogada = Jogada.AbandonarRodada;
						System.err.println("Problemas na jogada atual: " + jogadores[idDoTime(proximoAJogar)].nomeDoJogador());
					}
					if (LOG) System.out.println("  =" + ultimaJogada.toString() + "  " + temp.toString());
					

					if (ultimaJogada == Jogada.SolicitarAumento){
						
						if (estadoAtual.valorAtualDaRodada == 9 && penultimaJogada!=null && penultimaJogada==Jogada.SolicitarAumento){
							System.err.println("O time " + proximoAJogar.toString() + " tentou aumentar aps os 12 pontos: "  + jogadores[idDoTime(temp)].nomeDoJogador());
							/*
							if (temp == Time.Time1){
								resultado[1] = estadoAtual.valorAtualDaRodada;
							}else{
								resultado[0] = estadoAtual.valorAtualDaRodada;	
							}
							return resultado;
							*/
							ultimaJogada = Jogada.AceitarAumento;
						}else{

						
						
						estadoAtual.quantidadeDeVezesQueAceitou[idDoTime(temp)]++;
						estadoAtual.quantidadeDeVezesAumentou[idDoTime(temp)]++;
						estadoAtual.ultimoAAumentar = temp;
						estadoAtual.valorAtualDaRodada += 3;
						if (estadoAtual.valorAtualDaRodada == 4) estadoAtual.valorAtualDaRodada = 3;
						temp = outroTime(temp);
						}
					}
				}
				if (ultimaJogada == Jogada.AbandonarRodada){
					resultado[idDoTime(temp)] = 0;
					resultado[idDoTime(outroTime(temp))] = estadoAtual.valorAtualDaRodada;
					return resultado;
				}else {
					estadoAtual.quantidadeDeVezesQueAceitou[idDoTime(temp)]++;
					estadoAtual.valorAtualDaRodada += 3;
					if (estadoAtual.valorAtualDaRodada == 4) estadoAtual.valorAtualDaRodada = 3;
				}
			}
			
			
		}
		return resultado;
	}
	
	public static Time outroTime(Time time){
		if (time == Time.Time1) return Time.Time2;
		else if (time == Time.Time2) return Time.Time1;
		return Time.Nenhum;
	}
	
	public static int idDoTime(Time time){
		if (time==Time.Time1) return 0;
		return 1;
	}
}
